Index: uspace/srv/hid/input/ctl/kbdev.c
===================================================================
--- uspace/srv/hid/input/ctl/kbdev.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/input/ctl/kbdev.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -94,6 +94,6 @@
 static int kbdev_ctl_init(kbd_dev_t *kdev)
 {
-	async_sess_t *sess = loc_service_connect(EXCHANGE_SERIALIZE,
-	    kdev->svc_id, 0);
+	async_sess_t *sess = loc_service_connect(kdev->svc_id,
+	    INTERFACE_DDF, 0);
 	if (sess == NULL) {
 		printf("%s: Failed starting session with '%s.'\n", NAME,
@@ -120,5 +120,8 @@
 	}
 	
-	int rc = async_connect_to_me(exch, 0, 0, 0, kbdev_callback_conn, kbdev);
+	port_id_t port;
+	int rc = async_create_callback_port(exch, INTERFACE_KBD_CB, 0, 0,
+	    kbdev_callback_conn, kbdev, &port);
+	
 	if (rc != EOK) {
 		printf("%s: Failed creating callback connection from '%s'.\n",
Index: uspace/srv/hid/input/input.c
===================================================================
--- uspace/srv/hid/input/input.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/input/input.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -745,6 +745,6 @@
 	if (irc_service) {
 		while (irc_sess == NULL)
-			irc_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
-			    SERVICE_IRC, 0, 0);
+			irc_sess = service_connect_blocking(SERVICE_IRC,
+			    INTERFACE_IRC, 0);
 	}
 	
@@ -758,5 +758,5 @@
 	async_set_client_data_constructor(client_data_create);
 	async_set_client_data_destructor(client_data_destroy);
-	async_set_client_connection(client_connection);
+	async_set_fallback_port_handler(client_connection, NULL);
 	
 	int rc = loc_server_register(NAME);
Index: uspace/srv/hid/input/port/adb.c
===================================================================
--- uspace/srv/hid/input/port/adb.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/input/port/adb.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -69,5 +69,5 @@
 		return rc;
 	
-	dev_sess = loc_service_connect(EXCHANGE_ATOMIC, service_id, 0);
+	dev_sess = loc_service_connect(service_id, INTERFACE_DDF, 0);
 	if (dev_sess == NULL) {
 		printf("%s: Failed to connect to device\n", NAME);
@@ -82,5 +82,8 @@
 	}
 	
-	rc = async_connect_to_me(exch, 0, 0, 0, kbd_port_events, NULL);
+	port_id_t port;
+	rc = async_create_callback_port(exch, INTERFACE_ADB_CB, 0, 0,
+	    kbd_port_events, NULL, &port);
+	
 	async_exchange_end(exch);
 	if (rc != EOK) {
Index: uspace/srv/hid/input/port/adb_mouse.c
===================================================================
--- uspace/srv/hid/input/port/adb_mouse.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/input/port/adb_mouse.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -84,5 +84,5 @@
 		return rc;
 	
-	dev_sess = loc_service_connect(EXCHANGE_ATOMIC, service_id, 0);
+	dev_sess = loc_service_connect(service_id, INTERFACE_DDF, 0);
 	if (dev_sess == NULL) {
 		printf("%s: Failed to connect to device\n", NAME);
@@ -98,5 +98,8 @@
 	
 	/* NB: The callback connection is slotted for removal */
-	rc = async_connect_to_me(exch, 0, 0, 0, mouse_port_events, NULL);
+	port_id_t port;
+	rc = async_create_callback_port(exch, INTERFACE_ADB_CB, 0, 0,
+	    mouse_port_events, NULL, &port);
+	
 	async_exchange_end(exch);
 	if (rc != EOK) {
Index: uspace/srv/hid/input/port/chardev.c
===================================================================
--- uspace/srv/hid/input/port/chardev.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/input/port/chardev.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -84,5 +84,5 @@
 	}
 	
-	dev_sess = loc_service_connect(EXCHANGE_ATOMIC, service_id,
+	dev_sess = loc_service_connect(service_id, INTERFACE_DDF,
 	    IPC_FLAG_BLOCKING);
 	if (dev_sess == NULL) {
@@ -98,6 +98,8 @@
 	}
 	
-	/* NB: The callback connection is slotted for removal */
-	rc = async_connect_to_me(exch, 0, 0, 0, kbd_port_events, NULL);
+	port_id_t port;
+	rc = async_create_callback_port(exch, INTERFACE_CHAR_CB, 0, 0,
+	    kbd_port_events, NULL, &port);
+	
 	async_exchange_end(exch);
 	
Index: uspace/srv/hid/input/proto/mousedev.c
===================================================================
--- uspace/srv/hid/input/proto/mousedev.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/input/proto/mousedev.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -118,6 +118,5 @@
 static int mousedev_proto_init(mouse_dev_t *mdev)
 {
-	async_sess_t *sess = loc_service_connect(EXCHANGE_SERIALIZE,
-	    mdev->svc_id, 0);
+	async_sess_t *sess = loc_service_connect(mdev->svc_id, INTERFACE_DDF, 0);
 	if (sess == NULL) {
 		printf("%s: Failed starting session with '%s'\n", NAME,
@@ -143,5 +142,8 @@
 	}
 	
-	int rc = async_connect_to_me(exch, 0, 0, 0, mousedev_callback_conn, mousedev);
+	port_id_t port;
+	int rc = async_create_callback_port(exch, INTERFACE_MOUSE_CB, 0, 0,
+	    mousedev_callback_conn, mousedev, &port);
+	
 	async_exchange_end(exch);
 	async_hangup(sess);
Index: uspace/srv/hid/isdv4_tablet/main.c
===================================================================
--- uspace/srv/hid/isdv4_tablet/main.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/isdv4_tablet/main.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -69,8 +69,10 @@
 	async_sess_t *sess =
 	    async_callback_receive(EXCHANGE_SERIALIZE);
+	
 	fibril_mutex_lock(&client_mutex);
-		if (client_sess == NULL) {
-			client_sess = sess;
-		}
+	
+	if (client_sess == NULL)
+		client_sess = sess;
+	
 	fibril_mutex_unlock(&client_mutex);
 
@@ -262,5 +264,5 @@
 	printf(NAME ": Using serial port %s\n", serial_port_name);
 
-	async_sess_t *sess = loc_service_connect(EXCHANGE_SERIALIZE, svc_id,
+	async_sess_t *sess = loc_service_connect(svc_id, INTERFACE_DDF,
 	    IPC_FLAG_BLOCKING);
 	if (!sess) {
@@ -306,5 +308,5 @@
 	fibril_add_ready(fibril);
 
-	async_set_client_connection(mouse_connection);
+	async_set_fallback_port_handler(mouse_connection, NULL);
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
Index: uspace/srv/hid/output/output.c
===================================================================
--- uspace/srv/hid/output/output.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/output/output.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -460,5 +460,5 @@
 	
 	/* Register server */
-	async_set_client_connection(client_connection);
+	async_set_fallback_port_handler(client_connection, NULL);
 	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
Index: uspace/srv/hid/remcons/remcons.c
===================================================================
--- uspace/srv/hid/remcons/remcons.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/remcons/remcons.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -217,5 +217,5 @@
 {
 	/* Find the user. */
-	telnet_user_t *user = telnet_user_get_for_client_connection(IPC_GET_ARG1(*icall));
+	telnet_user_t *user = telnet_user_get_for_client_connection(IPC_GET_ARG2(*icall));
 	if (user == NULL) {
 		async_answer_0(iid, ENOENT);
@@ -348,5 +348,5 @@
 	inet_ep_t ep;
 
-	async_set_client_connection(client_connection);
+	async_set_fallback_port_handler(client_connection, NULL);
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
Index: uspace/srv/hid/rfb/main.c
===================================================================
--- uspace/srv/hid/rfb/main.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/rfb/main.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -215,5 +215,5 @@
 	vis->dev_ctx = NULL;
 
-	async_set_client_connection(client_connection);
+	async_set_fallback_port_handler(client_connection, NULL);
 
 	int rc = loc_server_register(NAME);
Index: uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c
===================================================================
--- uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -85,5 +85,5 @@
 	printf("%s: S3C24xx touchscreen driver\n", NAME);
 	
-	async_set_client_connection(s3c24xx_ts_connection);
+	async_set_fallback_port_handler(s3c24xx_ts_connection, NULL);
 	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
Index: uspace/srv/hw/bus/cuda_adb/cuda_adb.c
===================================================================
--- uspace/srv/hw/bus/cuda_adb/cuda_adb.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hw/bus/cuda_adb/cuda_adb.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -169,5 +169,5 @@
 	}
 
-	async_set_client_connection(cuda_connection);
+	async_set_fallback_port_handler(cuda_connection, NULL);
 	rc = loc_server_register(NAME);
 	if (rc < 0) {
@@ -214,5 +214,5 @@
 
 	/* Get the device handle. */
-	dsid = IPC_GET_ARG1(*icall);
+	dsid = IPC_GET_ARG2(*icall);
 
 	/* Determine which disk device is the client connecting to. */
Index: uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -77,5 +77,5 @@
 	printf("%s: S3C24xx on-chip UART driver\n", NAME);
 	
-	async_set_client_connection(s3c24xx_uart_connection);
+	async_set_fallback_port_handler(s3c24xx_uart_connection, NULL);
 	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
Index: uspace/srv/hw/irc/apic/apic.c
===================================================================
--- uspace/srv/hw/irc/apic/apic.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hw/irc/apic/apic.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -215,5 +215,5 @@
 	}
 	
-	async_set_client_connection(apic_connection);
+	async_set_fallback_port_handler(apic_connection, NULL);
 	service_register(SERVICE_IRC);
 	
Index: uspace/srv/hw/irc/i8259/i8259.c
===================================================================
--- uspace/srv/hw/irc/i8259/i8259.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hw/irc/i8259/i8259.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -153,5 +153,5 @@
 	}
 	
-	async_set_client_connection(i8259_connection);
+	async_set_fallback_port_handler(i8259_connection, NULL);
 	service_register(SERVICE_IRC);
 	
Index: uspace/srv/hw/irc/icp-ic/icp-ic.c
===================================================================
--- uspace/srv/hw/irc/icp-ic/icp-ic.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hw/irc/icp-ic/icp-ic.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -150,5 +150,5 @@
 	icpic_regs = (icpic_regs_t *)regs;
 
-	async_set_client_connection(icpic_connection);
+	async_set_fallback_port_handler(icpic_connection, NULL);
 	service_register(SERVICE_IRC);
 
Index: uspace/srv/hw/irc/obio/obio.c
===================================================================
--- uspace/srv/hw/irc/obio/obio.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/hw/irc/obio/obio.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -137,5 +137,5 @@
 	printf("%s: OBIO registers with base at %zu\n", NAME, base_phys);
 	
-	async_set_client_connection(obio_connection);
+	async_set_fallback_port_handler(obio_connection, NULL);
 	service_register(SERVICE_IRC);
 	
Index: uspace/srv/loader/main.c
===================================================================
--- uspace/srv/loader/main.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/loader/main.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -249,5 +249,5 @@
 		}
 		async_state_change_finalize(callid, vfs_exch);
-		fd = fd_wait();
+		fd = vfs_fd_wait();
 		assert(fd == (int) filc);
 	}
@@ -443,6 +443,5 @@
 int main(int argc, char *argv[])
 {
-	/* Set a handler of incomming connections. */
-	async_set_client_connection(ldr_connection);
+	async_set_fallback_port_handler(ldr_connection, NULL);
 	
 	/* Introduce this task to the NS (give it our task ID). */
@@ -452,9 +451,15 @@
 		return rc;
 	
-	/* Register at naming service. */
-	rc = service_register(SERVICE_LOAD);
+	/* Create port */
+	port_id_t port;
+	rc = async_create_port(INTERFACE_LOADER, ldr_connection, NULL, &port);
 	if (rc != EOK)
 		return rc;
 	
+	/* Register at naming service. */
+	rc = service_register(SERVICE_LOADER);
+	if (rc != EOK)
+		return rc;
+	
 	async_manager();
 	
Index: uspace/srv/locsrv/locsrv.c
===================================================================
--- uspace/srv/locsrv/locsrv.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/locsrv/locsrv.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -412,5 +412,5 @@
 {
 	if (server == NULL)
-		return EEXISTS;
+		return EEXIST;
 	
 	fibril_mutex_lock(&servers_list_mutex);
@@ -467,7 +467,4 @@
 	}
 	
-	/* Set the interface, if any. */
-	service->forward_interface = IPC_GET_ARG1(*icall);
-
 	/* Get fqsn */
 	char *fqsn;
@@ -514,5 +511,5 @@
 		free(service->name);
 		free(service);
-		async_answer_0(iid, EEXISTS);
+		async_answer_0(iid, EEXIST);
 		return;
 	}
@@ -702,5 +699,5 @@
  *
  */
-static void loc_forward(ipc_callid_t callid, ipc_call_t *call)
+static void loc_forward(ipc_callid_t callid, ipc_call_t *call, void *arg)
 {
 	fibril_mutex_lock(&services_list_mutex);
@@ -709,4 +706,5 @@
 	 * Get ID from request
 	 */
+	iface_t iface = IPC_GET_ARG1(*call);
 	service_id_t id = IPC_GET_ARG2(*call);
 	loc_service_t *svc = loc_service_find_id(id);
@@ -719,11 +717,5 @@
 	
 	async_exch_t *exch = async_exchange_begin(svc->server->sess);
-	
-	if (svc->forward_interface == 0)
-		async_forward_fast(callid, exch, svc->id, 0, 0, IPC_FF_NONE);
-	else
-		async_forward_fast(callid, exch, svc->forward_interface,
-		    svc->id, 0, IPC_FF_NONE);
-	
+	async_forward_fast(callid, exch, iface, svc->id, 0, IPC_FF_NONE);
 	async_exchange_end(exch);
 	
@@ -959,5 +951,5 @@
 	    loc_namespace_find_id(IPC_GET_ARG1(*icall));
 	if (namespace == NULL)
-		async_answer_0(iid, EEXISTS);
+		async_answer_0(iid, EEXIST);
 	else
 		async_answer_1(iid, EOK, namespace->refcnt);
@@ -1382,5 +1374,5 @@
  *
  */
-static void loc_connection_supplier(ipc_callid_t iid, ipc_call_t *icall)
+static void loc_connection_supplier(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
 	/* Accept connection */
@@ -1440,5 +1432,5 @@
  *
  */
-static void loc_connection_consumer(ipc_callid_t iid, ipc_call_t *icall)
+static void loc_connection_consumer(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
 	/* Accept connection */
@@ -1507,27 +1499,4 @@
 }
 
-/** Function for handling connections to location service
- *
- */
-static void loc_connection(ipc_callid_t iid, ipc_call_t *icall, void *arg)
-{
-	/* Select interface */
-	switch ((sysarg_t) (IPC_GET_ARG1(*icall))) {
-	case LOC_PORT_SUPPLIER:
-		loc_connection_supplier(iid, icall);
-		break;
-	case LOC_PORT_CONSUMER:
-		loc_connection_consumer(iid, icall);
-		break;
-	case LOC_CONNECT_TO_SERVICE:
-		/* Connect client to selected service */
-		loc_forward(iid, icall);
-		break;
-	default:
-		/* No such interface */
-		async_answer_0(iid, ENOENT);
-	}
-}
-
 /**
  *
@@ -1542,12 +1511,23 @@
 	}
 	
-	/* Set a handler of incomming connections */
-	async_set_client_connection(loc_connection);
-	
-	/* Register location service at naming service */
-	int rc = service_register(SERVICE_LOC);
+	port_id_t port;
+	int rc = async_create_port(INTERFACE_LOC_SUPPLIER,
+	    loc_connection_supplier, NULL, &port);
 	if (rc != EOK)
 		return rc;
 	
+	rc = async_create_port(INTERFACE_LOC_CONSUMER,
+	    loc_connection_consumer, NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	/* Set a handler of incomming connections */
+	async_set_fallback_port_handler(loc_forward, NULL);
+	
+	/* Register location service at naming service */
+	rc = service_register(SERVICE_LOC);
+	if (rc != EOK)
+		return rc;
+	
 	printf("%s: Accepting connections\n", NAME);
 	async_manager();
Index: uspace/srv/locsrv/locsrv.h
===================================================================
--- uspace/srv/locsrv/locsrv.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/locsrv/locsrv.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -107,7 +107,4 @@
 	/** Supplier of this service */
 	loc_server_t *server;
-	
-	/** Use this interface when forwarding to server. */
-	sysarg_t forward_interface;
 } loc_service_t;
 
Index: uspace/srv/logger/main.c
===================================================================
--- uspace/srv/logger/main.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/logger/main.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -48,19 +48,14 @@
 #include "logger.h"
 
-static void connection_handler(ipc_callid_t iid, ipc_call_t *icall, void *arg)
+static void connection_handler_control(ipc_callid_t iid, ipc_call_t *icall,
+    void *arg)
 {
-	logger_interface_t iface = IPC_GET_ARG1(*icall);
+	logger_connection_handler_control(iid);
+}
 
-	switch (iface) {
-	case LOGGER_INTERFACE_CONTROL:
-		logger_connection_handler_control(iid);
-		break;
-	case LOGGER_INTERFACE_WRITER:
-		logger_connection_handler_writer(iid);
-		break;
-	default:
-		async_answer_0(iid, EINVAL);
-		break;
-	}
+static void connection_handler_writer(ipc_callid_t iid, ipc_call_t *icall,
+    void *arg)
+{
+	logger_connection_handler_writer(iid);
 }
 
@@ -73,8 +68,17 @@
 		parse_level_settings(argv[i]);
 	}
-
-	async_set_client_connection(connection_handler);
 	
-	int rc = service_register(SERVICE_LOGGER);
+	port_id_t port;
+	int rc = async_create_port(INTERFACE_LOGGER_CONTROL,
+	    connection_handler_control, NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	rc = async_create_port(INTERFACE_LOGGER_WRITER,
+	    connection_handler_writer, NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	rc = service_register(SERVICE_LOGGER);
 	if (rc != EOK) {
 		printf(NAME ": failed to register: %s.\n", str_error(rc));
Index: uspace/srv/net/dhcp/main.c
===================================================================
--- uspace/srv/net/dhcp/main.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/dhcp/main.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -65,5 +65,5 @@
 	}
 
-	async_set_client_connection(dhcp_client_conn);
+	async_set_fallback_port_handler(dhcp_client_conn, NULL);
 
 	rc = loc_server_register(NAME);
Index: uspace/srv/net/dnsrsrv/dnsrsrv.c
===================================================================
--- uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -64,5 +64,5 @@
 	}
 
-	async_set_client_connection(dnsr_client_conn);
+	async_set_fallback_port_handler(dnsr_client_conn, NULL);
 
 	rc = loc_server_register(NAME);
Index: uspace/srv/net/ethip/ethip.c
===================================================================
--- uspace/srv/net/ethip/ethip.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/ethip/ethip.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -79,5 +79,5 @@
 static int ethip_init(void)
 {
-	async_set_client_connection(ethip_client_conn);
+	async_set_fallback_port_handler(ethip_client_conn, NULL);
 	
 	int rc = loc_server_register(NAME);
@@ -147,5 +147,5 @@
 	service_id_t sid;
 
-	sid = (service_id_t)IPC_GET_ARG1(*icall);
+	sid = (service_id_t) IPC_GET_ARG2(*icall);
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_client_conn(%u)", (unsigned)sid);
 	nic = ethip_nic_find_by_iplink_sid(sid);
Index: uspace/srv/net/ethip/ethip_nic.c
===================================================================
--- uspace/srv/net/ethip/ethip_nic.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/ethip/ethip_nic.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -162,5 +162,5 @@
 	}
 	
-	nic->sess = loc_service_connect(EXCHANGE_SERIALIZE, sid, 0);
+	nic->sess = loc_service_connect(sid, INTERFACE_DDF, 0);
 	if (nic->sess == NULL) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed connecting '%s'", nic->svc_name);
Index: uspace/srv/net/inetsrv/addrobj.c
===================================================================
--- uspace/srv/net/inetsrv/addrobj.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/inetsrv/addrobj.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -87,5 +87,5 @@
 		/* Duplicate address name */
 		fibril_mutex_unlock(&addr_list_lock);
-		return EEXISTS;
+		return EEXIST;
 	}
 
Index: uspace/srv/net/inetsrv/inet_link.c
===================================================================
--- uspace/srv/net/inetsrv/inet_link.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/inetsrv/inet_link.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -177,5 +177,5 @@
 	}
 
-	ilink->sess = loc_service_connect(EXCHANGE_SERIALIZE, sid, 0);
+	ilink->sess = loc_service_connect(sid, INTERFACE_IPLINK, 0);
 	if (ilink->sess == NULL) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed connecting '%s'", ilink->svc_name);
Index: uspace/srv/net/inetsrv/inetsrv.c
===================================================================
--- uspace/srv/net/inetsrv/inetsrv.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/inetsrv/inetsrv.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -77,16 +77,30 @@
 };
 
-static void inet_client_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg);
-
 static FIBRIL_MUTEX_INITIALIZE(client_list_lock);
 static LIST_INITIALIZE(client_list);
 
+static void inet_default_conn(ipc_callid_t, ipc_call_t *, void *);
+
 static int inet_init(void)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_init()");
 	
-	async_set_client_connection(inet_client_conn);
-	
-	int rc = loc_server_register(NAME);
+	port_id_t port;
+	int rc = async_create_port(INTERFACE_INET,
+	    inet_default_conn, NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	rc = async_create_port(INTERFACE_INETCFG,
+	    inet_cfg_conn, NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	rc = async_create_port(INTERFACE_INETPING,
+	    inetping_conn, NULL, &port);
+	if (rc != EOK)
+		return rc;
+	
+	rc = loc_server_register(NAME);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server (%d).", rc);
@@ -95,20 +109,5 @@
 	
 	service_id_t sid;
-	rc = loc_service_register_with_iface(SERVICE_NAME_INET, &sid,
-	    INET_PORT_DEFAULT);
-	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
-		return EEXIST;
-	}
-	
-	rc = loc_service_register_with_iface(SERVICE_NAME_INETCFG, &sid,
-	    INET_PORT_CFG);
-	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
-		return EEXIST;
-	}
-	
-	rc = loc_service_register_with_iface(SERVICE_NAME_INETPING, &sid,
-	    INET_PORT_PING);
+	rc = loc_service_register(SERVICE_NAME_INET, &sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
@@ -429,26 +428,4 @@
 }
 
-static void inet_client_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg)
-{
-	sysarg_t port;
-
-	port = IPC_GET_ARG1(*icall);
-
-	switch (port) {
-	case INET_PORT_DEFAULT:
-		inet_default_conn(iid, icall, arg);
-		break;
-	case INET_PORT_CFG:
-		inet_cfg_conn(iid, icall, arg);
-		break;
-	case INET_PORT_PING:
-		inetping_conn(iid, icall, arg);
-		break;
-	default:
-		async_answer_0(iid, ENOTSUP);
-		break;
-	}
-}
-
 static inet_client_t *inet_client_find(uint8_t proto)
 {
Index: uspace/srv/net/loopip/loopip.c
===================================================================
--- uspace/srv/net/loopip/loopip.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/loopip/loopip.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -100,5 +100,5 @@
 static int loopip_init(void)
 {
-	async_set_client_connection(loopip_client_conn);
+	async_set_fallback_port_handler(loopip_client_conn, NULL);
 	
 	int rc = loc_server_register(NAME);
Index: uspace/srv/net/nconfsrv/nconfsrv.c
===================================================================
--- uspace/srv/net/nconfsrv/nconfsrv.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/nconfsrv/nconfsrv.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -77,5 +77,5 @@
 	}
 
-	async_set_client_connection(ncs_client_conn);
+	async_set_fallback_port_handler(ncs_client_conn, NULL);
 
 	rc = loc_server_register(NAME);
Index: uspace/srv/net/slip/slip.c
===================================================================
--- uspace/srv/net/slip/slip.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/slip/slip.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -300,5 +300,5 @@
 	slip_iplink.ops = &slip_iplink_ops;
 
-	async_set_client_connection(slip_client_conn);
+	async_set_fallback_port_handler(slip_client_conn, NULL);
 
 	rc = loc_server_register(NAME);
@@ -328,5 +328,5 @@
 	 * char_dev at the same time.
 	 */
-	sess_out = loc_service_connect(EXCHANGE_SERIALIZE, svcid, 0);
+	sess_out = loc_service_connect(svcid, INTERFACE_DDF, 0);
 	if (!sess_out) {
 		log_msg(LOG_DEFAULT, LVL_ERROR,
@@ -337,5 +337,5 @@
 	slip_iplink.arg = sess_out;
 
-	sess_in = loc_service_connect(EXCHANGE_SERIALIZE, svcid, 0);
+	sess_in = loc_service_connect(svcid, INTERFACE_DDF, 0);
 	if (!sess_in) {
 		log_msg(LOG_DEFAULT, LVL_ERROR,
Index: uspace/srv/net/tcp/conn.c
===================================================================
--- uspace/srv/net/tcp/conn.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/tcp/conn.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -1223,5 +1223,5 @@
 		rc = amap_insert(amap, &conn->ident, conn, af_allow_system, &aepp);
 		if (rc != EOK) {
-			assert(rc != EEXISTS);
+			assert(rc != EEXIST);
 			assert(rc == ENOMEM);
 			log_msg(LOG_DEFAULT, LVL_ERROR, "Out of memory.");
